<!--
 * @Descripttion:
 * @version:
 * @Author: kBank
 * @Date: 2022-10-24 15:45:01
-->
<template>
  <div class="page">
    <topBar v-if="topList.length > 0"
            :topList="topList"
            :moren="moren"></topBar>
    <div class="main">
      <div class="maintop">
        <div class="mainbtn">
          <el-button size="small"
                     @click="openDig"
                     v-hasButtons="['BigThingsAdd']"
                     class="addBtn">{{'添加'}}</el-button>
        </div>
      </div>
      <div class="maintable">
        <el-table :data="tableData"
        v-loading="loading"
                  style="width: 100%"
                  :header-cell-style="{ background: '#EEEEEE' }"
                  :row-class-name="tableRowClassName"
                  @selection-change="handleSelectionChange">
          <el-table-column type="selection"
                           width="55"> </el-table-column>
          <el-table-column align="center"
                           prop="sort"
                           :label="'排序'"> </el-table-column>
          <el-table-column align="center"
                           prop=""
                           :label="'图片'">
            <template slot-scope="scope">
              <div class="img">
                <img :src="scope.row.picture"
                     alt="">
              </div>
            </template>
          </el-table-column>

          <el-table-column align="center"
                           prop="creationTime"
                           :label="'创建日期'">
          </el-table-column>
          <el-table-column align="center"
                           prop="effectiveDate"
                           :label="'生效日期'">
          </el-table-column>
          <el-table-column align="center"
                           prop="time"
                           :label="'操作'"
                           width="300"
                           fixed="right">
            <template slot-scope="scope">
              <el-button @click="upList(scope.row.pkId)"
                         type="text"
                         v-hasButtons="['BigThingsUp']"
                         size="small">
                {{'上移'}}
              </el-button>
              <el-button @click="downList(scope.row.pkId)"
                         type="text"
                         v-hasButtons="['BigThingsDown']"
                         size="small">
                {{'下移'}}
              </el-button>
              <el-button @click="toFixed(scope.row.pkId)"
                         type="text" style="color:#48B2FD"
                         size="small">
                {{ '查看' }}
              </el-button>
              <el-button @click="handleDelete(scope.row.pkId)"
                         type="text"
                         size="small"
                         v-hasButtons="['BigThingsDelete']"
                         style="color: #C8161D">
                {{ '删除' }}
              </el-button>
              <el-button v-if="scope.row.sort!=1"
                         @click="toTopList(scope.row.pkId)"
                         type="text"
                         v-hasButtons="['BigThingsTop']"
                         size="small"
                         style="color: #c73030">
                {{'置顶'}}
              </el-button>
            </template>
          </el-table-column>
        </el-table>
      </div>
    </div>
    <pagination v-show="total>0"
                :total="total"
                :page.sync="queryParams.pageNum"
                :limit.sync="queryParams.pageSize"
                @pagination="getDataList" />
    <el-dialog :title="addOrEdit?'添加':'查看'"
               :close-on-click-modal="false"
               :visible.sync="dialogVisible"
               width="40%"
               center
               :before-close="handleClose">
      <el-form ref="form"
               :rules="rules"
               :model="form"
               label-width="80px">
        <el-row>
          <el-col :span="12">
            <el-form-item :label="'排序'">
              <el-input clearable
                        v-model="form.sort"
                        :placeholder="'请输入'"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="'生效日期'">
              <el-date-picker v-model="form.effectiveDate"
                              value-format="yyyy-MM-dd HH:mm:ss"
                              type="date"
                              :placeholder="'请选择'">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="'上传图片'">
              <imageUpload v-model="form.picture" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <span slot="footer"
            class="dialog-footer">
        <el-button @click="handleClose">{{'取消'}}</el-button>
        <el-button type="primary"
                   @click="onSubmit('form')">{{'确认'}}</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import topBar from '@/components/topBar'
import * as api from '@/api/site.js'
import { classifyUpdate, classifySave } from '@/api/product'
import ImageUpload from '@/components/ImageUpload'

export default {
  name: 'Bzpz',
  components: {
    topBar,
    ImageUpload,
  },
  filters: {
     isAgree(val) {
      if (!val) {
        return '允许';
      } else {
        return '禁止';
      }
    },
  },
  data() {
    return {
      typeList: [
        {
          value: 0,
          label: '前台',
        },
        {
          value: 1,
          label: '后台',
        },
      ],
      digList: [
        {
          value: 0,
          label: '允许',
        },
        {
          value: 1,
          label: '禁止',
        },
      ],
      creationTime: [],
      creationTime1: [],
      select: {},
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50,
      },
      addOrEdit: '',
      total: 0,
      dialogVisible: false,
      tableData: [],
      loading:false,
      moren: '/siteConfiguration/bigThings',
      topList: [
        {
          name: '荣誉资质',
          path: '/siteConfiguration/bigThings',
        },
        {
          name: '发展历程',
          path: '/siteConfiguration/bigThingsTwo',
        },
      ],
      form: {
        sort: '',
        creationTime: '',
        picture: '',
      },
      rules: {
        name: [{ required: true, message: '请输入规格类型', trigger: 'blur' }],
      },
      webList: [],
      localList: [],
      popList: [],
      gradeList: [],
      stateList: [],
    }
  },
  mounted() {
    // 获取下拉
    // this.getData()
    // 获取列表
    this.getDataList()
  },
  methods: {
    upList(id) {
      api.moveUp({ pkId: id }).then((res) => {
        this.getDataList()
      })
    },
    downList(id) {
      api.moveDown({ pkId: id }).then((res) => {
        this.getDataList()
      })
    },
    toTopList(id) {
      api.updateTopping({ pkId: id }).then((res) => {
        this.getDataList()
      })
    },
    getData() {
      api.noticeWebsite().then((res) => {
        this.webList = res.data
      })
      api.noticeLocation().then((res) => {
        this.localList = res.data
      })
      api.noticePopup().then((res) => {
        this.popList = res.data
      })
      api.noticeGrade().then((res) => {
        this.gradeList = res.data
      })
      api.noticeState().then((res) => {
        this.stateList = res.data
      })
    },
    changeTime(val) {
      this.select.startDate = val?val[0]:''
      this.select.endDate = val?val[1]:''
    },
    changeTime1(val) {
      this.select.startEffectDate = val?val[0]:''
      this.select.endEffectDate = val?val[1]:''
    },
    // 点击修改
    toFixed(id) {
      this.addOrEdit = false
      this.dialogVisible = true
      api.getOneHonor(id).then((res) => {
        this.form = res.data
      })
    },
    // 删除
    handleDelete(id) {
      this.$confirm('确认删除?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning',
      }).then(() => {
        api.honorDel(id).then((res) => {
          this.getDataList()
        })
      })
    },
    onSubmit(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          let url = ''
          if (this.addOrEdit == true) {
            url = api.honorSave
          } else {
            url = api.honorUpdate
          }
          url(this.form).then((res) => {
            if (res.code == 200) {
              this.$message({
                message: res.msg,
                type: 'success',
              })
              this.handleClose()
              // 获取列表
              this.getDataList()
            }
          })
        } else {
          return false
        }
      })
    },
    handleClose() {
      this.dialogVisible = false
      this.form = {}
      this.$refs['form'].clearValidate()
      this.$refs['form'].resetFields()
    },
    openDig() {
      this.addOrEdit = true
      this.dialogVisible = true
      this.$forceUpdate()
    },
    getDataList() {
      this.loading = true
      api
        .honorList(Object.assign({}, this.queryParams, this.select))
        .then((res) => {
          this.tableData = res.rows
          this.total = res.total
          this.loading = false
        })
    },
    handleSelectionChange(val) {},
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams
      this.$confirm( '是否确认导出所有数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning',
      })
        .then(function () {
          return api.exportClassIfy(queryParams)
        })
        .then((response) => {
          this.download(response)
        })
    },
    tableRowClassName({ row, rowIndex }) {
      if (rowIndex % 2 == 1) {
        return 'warning-row'
      } else if (rowIndex % 2 == 0) {
        return 'success-row'
      }
      return ''
    },
  },
}
</script>
<style scoped lang="scss">
::v-deep .el-button+.el-button{
  padding: 10px 5px;
}
::v-deep .el-table .warning-row {
  background: #f9f9f9;
}

::v-deep .el-table .success-row {
  background: #ffffff;
}
::v-deep .el-table thead {
  color: #000000;
}
::v-deep .el-select {
  width: 100%;
}
.uploadIcon ::v-deep .el-upload--picture-card {
  display: none !important; /* 上传按钮隐藏 */
}
.page {
  padding: 20px;
  background: #f9f9f9;
  font-size: 14px;
  .main {
    background: #ffffff;
    border-radius: 8px;
    box-shadow: 0px 2px 20px 0px rgba(238, 238, 238, 0.5);
    .maintop {
      display: flex;
      padding: 0px 0px;
      justify-content: space-between;
      align-items: center;
      background: #f8f8f8;
      .mainbtn {
        .thebtn1 {
          background: #3181e5;
          color: #ffffff;
        }
        .thebtn2 {
          background: #ffad41;
          color: #ffffff;
        }
      }
      .maintitle {
        font-size: 10px;
        font-family: MicrosoftYaHei;
        color: #999999;
      }
    }
  }
  .tem {
    display: flex;
    align-items: center;
    justify-content: center;
    img {
      width: 28px;
      height: 20px;
      margin-right: 3px;
    }
  }
  .isRed {
    color: #ed1d25;
  }
  .isGreen {
    color: #1ab62b;
  }
  .bgImg {
    width: 48px;
    height: 48px;
  }
}
.openClose {
  text-align: right;
  margin-right: 10px;
  color: #3181e5;
}
.img {
  img {
    width: 44px;
    height: 44px;
  }
}
</style>
